<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/myllgjacobian.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>myllgjacobian.c</h1><a href="myllgjacobian_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: myllgjacobian.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">extern</span> Mat <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="myllgjacobian_8c.html#a35010647607c93a40bdab3e86041714f">00033</a> <span class="keywordtype">int</span> <a class="code" href="llg_8h.html#a35010647607c93a40bdab3e86041714f">myLLGJacobian</a>(TS ts,PetscReal t,Vec global_in,Mat *AA,Mat *BB,MatStructure *str,<span class="keywordtype">void</span> *ctx)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <a class="code" href="structGridData.html">GridData</a>      *gdata = (<a class="code" href="structGridData.html">GridData</a>*)ctx;
<a name="l00036"></a>00036   Mat           A_Jij = *AA;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span>           i;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">/* just init with unity matrix for testing */</span>
<a name="l00043"></a>00043 <span class="comment">/*</span>
<a name="l00044"></a>00044 <span class="comment">  for (i=0; i&lt;ND*gdata-&gt;ln_vert; i++) {</span>
<a name="l00045"></a>00045 <span class="comment">    ierr = MatSetValue(A_Jij,i,i,1.0,INSERT_VALUES);CHKERRQ(ierr);</span>
<a name="l00046"></a>00046 <span class="comment">  }</span>
<a name="l00047"></a>00047 <span class="comment"></span>
<a name="l00048"></a>00048 <span class="comment">  PetscInfo(0,&quot;A_Jij matrix assembly complete\n&quot;);</span>
<a name="l00049"></a>00049 <span class="comment">  ierr = MatAssemblyBegin(A_Jij,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);</span>
<a name="l00050"></a>00050 <span class="comment">  ierr = MatAssemblyEnd(A_Jij,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);</span>
<a name="l00051"></a>00051 <span class="comment"></span>
<a name="l00052"></a>00052 <span class="comment">  *str = SAME_NONZERO_PATTERN;</span>
<a name="l00053"></a>00053 <span class="comment"></span>
<a name="l00054"></a>00054 <span class="comment">  MagparFunctionProfReturn(0);</span>
<a name="l00055"></a>00055 <span class="comment">*/</span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   PetscReal *ta_M,*ta_Htot;
<a name="l00058"></a>00058   ierr = VecGetArray(global_in,&amp;ta_M);CHKERRQ(ierr);
<a name="l00059"></a>00059   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);CHKERRQ(ierr);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="preprocessor">#if PETSC_VERSION &lt; 300</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>  ierr = MatSetOption(A_Jij,MAT_ROWS_SORTED);CHKERRQ(ierr);
<a name="l00063"></a>00063 <span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="comment">/*</span>
<a name="l00065"></a>00065 <span class="comment">  ierr = MatSetOption(A_Jij,MAT_NEW_NONZERO_LOCATION_ERR);CHKERRQ(ierr);</span>
<a name="l00066"></a>00066 <span class="comment">*/</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>       nonzeroes;
<a name="l00069"></a>00069   <span class="keyword">const</span> <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> *nonzcols;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   PetscTruth <a class="code" href="namespacegmshtoucd.html#af68c1546c900f7a17a20835183320d61">info</a>;
<a name="l00072"></a>00072   PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-info&quot;</span>,&amp;info);
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (info) {
<a name="l00074"></a>00074     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Recalculating matrix elements of Jacobian...\n&quot;</span>);
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00078"></a>00078     <span class="keywordflow">if</span> (info) {
<a name="l00079"></a>00079       ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(i,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,10);
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     ierr = MatGetRow(
<a name="l00083"></a>00083       <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,
<a name="l00084"></a>00084       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i],
<a name="l00085"></a>00085       &amp;nonzeroes,
<a name="l00086"></a>00086       (<span class="keyword">const</span> <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>**)&amp;nonzcols,
<a name="l00087"></a>00087       PETSC_NULL
<a name="l00088"></a>00088     );CHKERRQ(ierr);
<a name="l00089"></a>00089     ierr = MatRestoreRow(
<a name="l00090"></a>00090       <a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,
<a name="l00091"></a>00091       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i],
<a name="l00092"></a>00092       &amp;nonzeroes,
<a name="l00093"></a>00093       (<span class="keyword">const</span> <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>**)&amp;nonzcols,
<a name="l00094"></a>00094       PETSC_NULL
<a name="l00095"></a>00095     );CHKERRQ(ierr);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="comment">/* row=nodes1=i col=nodes2=j */</span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     PetscReal *xi,*hi;
<a name="l00100"></a>00100     xi=ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i;
<a name="l00101"></a>00101     hi=ta_Htot+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     <span class="keywordtype">int</span> rows[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00104"></a>00104     rows[0]=gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00105"></a>00105     rows[1]=rows[0]+1;
<a name="l00106"></a>00106     rows[2]=rows[0]+2;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108     <span class="comment">/* TODO: incorrect for mode 2: large damping, no precession for t&lt;0 */</span>
<a name="l00109"></a>00109     PetscReal  a1,alpha;
<a name="l00110"></a>00110     alpha=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+9];
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <span class="comment">/* skip calculation of Jacobian if Ms=0 or M is locked */</span>
<a name="l00113"></a>00113     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+4]&lt;=0.0 || alpha&gt;=<a class="code" href="griddata_8h.html#a8a54558688c833b1f886703d3012f1dd">RIGID_M_ALPHA</a>) <span class="keywordflow">continue</span>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     a1=1.0/(1.0+alpha*alpha);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="keywordtype">int</span> j;
<a name="l00118"></a>00118     j=-1;
<a name="l00119"></a>00119     <span class="comment">/* k increased by 1: matrix elements might be 0 by chance and therefore not stored! */</span>
<a name="l00120"></a>00120     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;nonzeroes; k++) {
<a name="l00121"></a>00121       <span class="comment">/* skip this triplet, if we have already completed it */</span>
<a name="l00122"></a>00122       <span class="keywordflow">if</span> (nonzcols[k]/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==j) <span class="keywordflow">continue</span>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124       j=nonzcols[k]/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="comment">/*    does not work: matrix elements might be 0 by chance and</span>
<a name="l00127"></a>00127 <span class="comment">      therefore not stored</span>
<a name="l00128"></a>00128 <span class="comment"></span>
<a name="l00129"></a>00129 <span class="comment">      assert(nonzcols[k]%ND==0);</span>
<a name="l00130"></a>00130 <span class="comment">*/</span>
<a name="l00131"></a>00131 
<a name="l00132"></a>00132       <span class="keywordtype">int</span> cols[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00133"></a>00133       cols[0]=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j;
<a name="l00134"></a>00134       cols[1]=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1;
<a name="l00135"></a>00135       cols[2]=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137       PetscReal dHdM[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00138"></a>00138       MatGetValues(<a class="code" href="hexch__ani_8c.html#a56704064cd6d4568b0172a2747dd3193">Ad2E_dMidMk</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)rows,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)cols,dHdM);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <span class="comment">/* row/column index correct ?</span>
<a name="l00141"></a>00141 <span class="comment">         dHdM should be symmetric anyway !? no: due to MatDiagonalScale !</span>
<a name="l00142"></a>00142 <span class="comment">      */</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144       PetscReal  *dh0dxi;
<a name="l00145"></a>00145       PetscReal  *dh1dxi;
<a name="l00146"></a>00146       PetscReal  *dh2dxi;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       dh0dxi = dHdM+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*0;
<a name="l00149"></a>00149       dh1dxi = dHdM+ND*1;
<a name="l00150"></a>00150       dh2dxi = dHdM+ND*2;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152       <span class="comment">/* TODO: explain this: why is this correct?</span>
<a name="l00153"></a>00153 <span class="comment">         without the else path: faster, but sphere_larmor does not preserve E, Mz!</span>
<a name="l00154"></a>00154 <span class="comment"></span>
<a name="l00155"></a>00155 <span class="comment">         Local field hi[]!=0 only on local node (rows[0]==cols[0]).</span>
<a name="l00156"></a>00156 <span class="comment">         However, dHidMj!=0 also on neighboring node</span>
<a name="l00157"></a>00157 <span class="comment">      */</span>
<a name="l00158"></a>00158       <span class="comment">/* TODO: incorrect for mode 2: large damping, no precession for t&lt;0 */</span>
<a name="l00159"></a>00159       PetscReal Jij[ND*ND];
<a name="l00160"></a>00160       <span class="keywordflow">if</span> (rows[0]==cols[0]) {
<a name="l00161"></a>00161         Jij[ND*0+0] = -(a1*(      -xi[2]*dh1dxi[0]+xi[1]*dh2dxi[0]))-a1*alpha*(   xi[1]*hi[1]+  xi[2]*hi[2]-xi[1]*xi[1]*dh0dxi[0]-xi[2]*xi[2]*dh0dxi[0]+xi[0]*xi[1]*dh1dxi[0]+xi[0]*xi[2]*dh2dxi[0]);
<a name="l00162"></a>00162         Jij[ND*1+0] = -(a1*(-hi[2]+xi[2]*dh0dxi[0]-xi[0]*dh2dxi[0]))-a1*alpha*(   xi[1]*hi[0]-2*xi[0]*hi[1]+xi[0]*xi[1]*dh0dxi[0]-xi[0]*xi[0]*dh1dxi[0]-xi[2]*xi[2]*dh1dxi[0]+xi[1]*xi[2]*dh2dxi[0]);
<a name="l00163"></a>00163         Jij[ND*2+0] = -(a1*( hi[1]-xi[1]*dh0dxi[0]+xi[0]*dh1dxi[0]))-a1*alpha*(   xi[2]*hi[0]-2*xi[0]*hi[2]+xi[0]*xi[2]*dh0dxi[0]+xi[1]*xi[2]*dh1dxi[0]-xi[0]*xi[0]*dh2dxi[0]-xi[1]*xi[1]*dh2dxi[0]);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165         Jij[ND*0+1] = -(a1*( hi[2]-xi[2]*dh1dxi[1]+xi[1]*dh2dxi[1]))-a1*alpha*(-2*xi[1]*hi[0]+  xi[0]*hi[1]-xi[1]*xi[1]*dh0dxi[1]-xi[2]*xi[2]*dh0dxi[1]+xi[0]*xi[1]*dh1dxi[1]+xi[0]*xi[2]*dh2dxi[1]);
<a name="l00166"></a>00166         Jij[ND*1+1] = -(a1*(       xi[2]*dh0dxi[1]-xi[0]*dh2dxi[1]))-a1*alpha*(   xi[0]*hi[0]+  xi[2]*hi[2]+xi[0]*xi[1]*dh0dxi[1]-xi[0]*xi[0]*dh1dxi[1]-xi[2]*xi[2]*dh1dxi[1]+xi[1]*xi[2]*dh2dxi[1]);
<a name="l00167"></a>00167         Jij[ND*2+1] = -(a1*(-hi[0]-xi[1]*dh0dxi[1]+xi[0]*dh1dxi[1]))-a1*alpha*(   xi[2]*hi[1]-2*xi[1]*hi[2]+xi[0]*xi[2]*dh0dxi[1]+xi[1]*xi[2]*dh1dxi[1]-xi[0]*xi[0]*dh2dxi[1]-xi[1]*xi[1]*dh2dxi[1]);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169         Jij[ND*0+2] = -(a1*(-hi[1]-xi[2]*dh1dxi[2]+xi[1]*dh2dxi[2]))-a1*alpha*(-2*xi[2]*hi[0]+  xi[0]*hi[2]-xi[1]*xi[1]*dh0dxi[2]-xi[2]*xi[2]*dh0dxi[2]+xi[0]*xi[1]*dh1dxi[2]+xi[0]*xi[2]*dh2dxi[2]);
<a name="l00170"></a>00170         Jij[ND*1+2] = -(a1*( hi[0]+xi[2]*dh0dxi[2]-xi[0]*dh2dxi[2]))-a1*alpha*(-2*xi[2]*hi[1]+  xi[1]*hi[2]+xi[0]*xi[1]*dh0dxi[2]-xi[0]*xi[0]*dh1dxi[2]-xi[2]*xi[2]*dh1dxi[2]+xi[1]*xi[2]*dh2dxi[2]);
<a name="l00171"></a>00171         Jij[ND*2+2] = -(a1*(      -xi[1]*dh0dxi[2]+xi[0]*dh1dxi[2]))-a1*alpha*(   xi[0]*hi[0]+  xi[1]*hi[1]+xi[0]*xi[2]*dh0dxi[2]+xi[1]*xi[2]*dh1dxi[2]-xi[0]*xi[0]*dh2dxi[2]-xi[1]*xi[1]*dh2dxi[2]);
<a name="l00172"></a>00172       }
<a name="l00173"></a>00173       <span class="keywordflow">else</span> {
<a name="l00174"></a>00174         Jij[ND*0+0] = -(a1*(      -xi[2]*dh1dxi[0]+xi[1]*dh2dxi[0]))-a1*alpha*(                            -xi[1]*xi[1]*dh0dxi[0]-xi[2]*xi[2]*dh0dxi[0]+xi[0]*xi[1]*dh1dxi[0]+xi[0]*xi[2]*dh2dxi[0]);
<a name="l00175"></a>00175         Jij[ND*1+0] = -(a1*(       xi[2]*dh0dxi[0]-xi[0]*dh2dxi[0]))-a1*alpha*(                            +xi[0]*xi[1]*dh0dxi[0]-xi[0]*xi[0]*dh1dxi[0]-xi[2]*xi[2]*dh1dxi[0]+xi[1]*xi[2]*dh2dxi[0]);
<a name="l00176"></a>00176         Jij[ND*2+0] = -(a1*(      -xi[1]*dh0dxi[0]+xi[0]*dh1dxi[0]))-a1*alpha*(                            +xi[0]*xi[2]*dh0dxi[0]+xi[1]*xi[2]*dh1dxi[0]-xi[0]*xi[0]*dh2dxi[0]-xi[1]*xi[1]*dh2dxi[0]);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178         Jij[ND*0+1] = -(a1*(      -xi[2]*dh1dxi[1]+xi[1]*dh2dxi[1]))-a1*alpha*(                            -xi[1]*xi[1]*dh0dxi[1]-xi[2]*xi[2]*dh0dxi[1]+xi[0]*xi[1]*dh1dxi[1]+xi[0]*xi[2]*dh2dxi[1]);
<a name="l00179"></a>00179         Jij[ND*1+1] = -(a1*(       xi[2]*dh0dxi[1]-xi[0]*dh2dxi[1]))-a1*alpha*(                            +xi[0]*xi[1]*dh0dxi[1]-xi[0]*xi[0]*dh1dxi[1]-xi[2]*xi[2]*dh1dxi[1]+xi[1]*xi[2]*dh2dxi[1]);
<a name="l00180"></a>00180         Jij[ND*2+1] = -(a1*(      -xi[1]*dh0dxi[1]+xi[0]*dh1dxi[1]))-a1*alpha*(                            +xi[0]*xi[2]*dh0dxi[1]+xi[1]*xi[2]*dh1dxi[1]-xi[0]*xi[0]*dh2dxi[1]-xi[1]*xi[1]*dh2dxi[1]);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182         Jij[ND*0+2] = -(a1*(      -xi[2]*dh1dxi[2]+xi[1]*dh2dxi[2]))-a1*alpha*(                            -xi[1]*xi[1]*dh0dxi[2]-xi[2]*xi[2]*dh0dxi[2]+xi[0]*xi[1]*dh1dxi[2]+xi[0]*xi[2]*dh2dxi[2]);
<a name="l00183"></a>00183         Jij[ND*1+2] = -(a1*(       xi[2]*dh0dxi[2]-xi[0]*dh2dxi[2]))-a1*alpha*(                             xi[0]*xi[1]*dh0dxi[2]-xi[0]*xi[0]*dh1dxi[2]-xi[2]*xi[2]*dh1dxi[2]+xi[1]*xi[2]*dh2dxi[2]);
<a name="l00184"></a>00184         Jij[ND*2+2] = -(a1*(      -xi[1]*dh0dxi[2]+xi[0]*dh1dxi[2]))-a1*alpha*(                             xi[0]*xi[2]*dh0dxi[2]+xi[1]*xi[2]*dh1dxi[2]-xi[0]*xi[0]*dh2dxi[2]-xi[1]*xi[1]*dh2dxi[2]);
<a name="l00185"></a>00185       }
<a name="l00186"></a>00186       ierr = MatSetValues(A_Jij,ND,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)rows,ND,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)cols,Jij,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00187"></a>00187     }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="preprocessor">#undef MATFLUSH</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span><span class="preprocessor">#ifdef MATFLUSH</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>    <span class="comment">/* flush caches to save memory (and avoid swapping) */</span>
<a name="l00192"></a>00192     <span class="keywordflow">if</span> (i % 100 == 99) {
<a name="l00193"></a>00193       ierr = MatAssemblyBegin(A_Jij,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00194"></a>00194       ierr = MatAssemblyEnd(A_Jij,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 <span class="preprocessor">#endif</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>  }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="preprocessor">#ifdef MATFLUSH</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span>  <span class="comment">/* continue assembling to stay in sync with other processors</span>
<a name="l00201"></a>00201 <span class="comment">     (MatAssembly is collective!)</span>
<a name="l00202"></a>00202 <span class="comment">  */</span>
<a name="l00203"></a>00203   <span class="keywordflow">for</span> (;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00204"></a>00204     <span class="keywordflow">if</span> (i % 100 == 99) {
<a name="l00205"></a>00205       ierr = MatAssemblyBegin(A_Jij,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00206"></a>00206       ierr = MatAssemblyEnd(A_Jij,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209 <span class="preprocessor">#endif</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (info) {
<a name="l00212"></a>00212     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00213"></a>00213   }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   PetscInfo(0,<span class="stringliteral">&quot;A_Jij matrix assembly complete\n&quot;</span>);
<a name="l00216"></a>00216   ierr = MatAssemblyBegin(A_Jij,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00217"></a>00217   ierr = MatAssemblyEnd(A_Jij,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="comment">/*</span>
<a name="l00220"></a>00220 <span class="comment">  ierr = MatView(A_Jij,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);</span>
<a name="l00221"></a>00221 <span class="comment">*/</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   VecRestoreArray(global_in,&amp;ta_M );
<a name="l00224"></a>00224   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   <span class="comment">/* TODO: optimize: */</span>
<a name="l00227"></a>00227 <span class="comment">/*</span>
<a name="l00228"></a>00228 <span class="comment">  *str = SAME_NONZERO_PATTERN;</span>
<a name="l00229"></a>00229 <span class="comment">*/</span>
<a name="l00230"></a>00230   *str = DIFFERENT_NONZERO_PATTERN;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

